﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace DataChartRealData
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DateTime begin = new DateTime(2012, 04, 17, 12, 30, 30, 0);
      
             
            
            


                        DateTime start = new DateTime(2012, 04, 17, 12, 32, 31, 0);
                        //DateTime startValue = start.AddMinutes(-2);
                        //startValue.AddSeconds(-31);

                        xAxis.MinimumValue = start.AddMinutes(-2).AddSeconds(-31).Ticks;
                        xAxis.Interval = 3000000000;
                       
                        
            ObservableCollection<Data> graphData = new ObservableCollection<Data>();

            graphData.Add(new Data{ Y = 1, TimeValue = start });

            //we want the first X axis label to start on 12:30pm on Apr 17, 2012
            //we want the other X axis labels on the graph to be on even 5 minute boundaries
            //New data points would be added to the collectio about 1 each second (but not guaranteed on each and every second)

            int ctr = 1;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(0.63) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(1.13) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(0.23) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(0.56) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(0.90) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(1.42) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(0.03) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(0.24) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(1.55) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(0.34) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(0.78) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(0.90) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(0.21) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(2.63) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(0.04) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(0.37) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(1.60) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start}); start= start.AddMinutes(0.63) ;
            graphData.Add(new Data { Y = ctr++ * 5, TimeValue = start});

            DataContext = graphData;

            xAxis.MaximumValue = start.AddMinutes(2).Ticks;
        }
    }


    public class Data
    {
        public double X { get { return TimeValue.Ticks;  } }
        public double Y { get; set; }
        public DateTime TimeValue { get; set; }
    }

    public class TicksToDateTimeConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value.GetType() == typeof(double))
            {
                long datetime = (long)System.Convert.ToUInt64(value);
                DateTime dt = new DateTime(datetime);
                return dt.ToString("hh:mm:ss");
            }

            return Binding.DoNothing;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }


        
    
}
